package org.mandarax.util.resultsetfilters.aggregationfunctions;

/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import org.mandarax.kernel.VariableTerm;
import org.mandarax.util.resultsetfilters.AggregationException;
import org.mandarax.util.resultsetfilters.AggregationFunction;
 
/**
 * MAX function.
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 3.0
 */

public class MAX extends AbstractAggregationFunction {
	private static Class[] supportedTypes = {
		Comparable.class		
	};
	/**
	 * Constructor.
	 * @param var the variable
	 * @param type the type of the term
	 */
	public MAX(VariableTerm var) throws AggregationException {
		super(var);
	}
	/**
	 * Get the name of this function.
	 * @return a name
	 */
	public String getName() {
		return "MAX";
	}
	/**
	 * Get an array of supported types.
	 * @return an array of types
	 */
	protected Class[] getSupportedTypes() {
		return supportedTypes;
	}
	/**
	 * Compute the aggregated value.
	 * @return the computed object
	 */
	protected Object compute() throws AggregationException {
		try {
			// the same for all types: sytring and numeric types implement
			// comparable !!!
			if (getNumberOfValues()==0) return null;
			else {
				Comparable max = getValueAsComparable(0);
				for (int i=1;i<getNumberOfValues();i++) {
					Comparable c =  getValueAsComparable(i);
					if (max.compareTo(c)<0) max = c; 
				}
				return max;
			}
			
		}
		catch (Throwable x) {
			throw new AggregationException("Error computing aggregated value",x);
		}
	}
	/**
	 * Copy this function (get a newly initialized instance of this class).
	 * @return a function
	 */
	public AggregationFunction copy() throws AggregationException {
		return new MAX(var);
	}

}
